<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.playlet.system.mapper.PlayletItemTypeMapper">

    <resultMap type="PlayletItemType" id="PlayletItemTypeResult">
        <result property="id"    column="id"    />
        <result property="name"    column="name"    />
        <result property="sourceType"    column="source_type"    />
        <result property="producerType"    column="producer_type"    />
        <result property="status"    column="status"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectPlayletItemTypeVo">
        select id, name, status, source_type, producer_type, create_by, create_time, update_by, update_time, remark from playlet_item_type
    </sql>

    <select id="selectPlayletItemTypeList" parameterType="PlayletItemType" resultMap="PlayletItemTypeResult">
        <include refid="selectPlayletItemTypeVo"/>
        <where>
            <if test="name != null  and name != ''"> and name like concat('%', #{name}, '%')</if>
            <if test="status != null  and status != ''"> and status = #{status}</if>
        </where>
    </select>

    <select id="selectPlayletItemTypeById" parameterType="Long" resultMap="PlayletItemTypeResult">
        <include refid="selectPlayletItemTypeVo"/>
        where id = #{id}
    </select>

    <insert id="insertPlayletItemType" parameterType="PlayletItemType" useGeneratedKeys="true" keyProperty="id">
        insert into playlet_item_type
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="name != null">name,</if>
            <if test="producerType != null">producer_type,</if>
            <if test="sourceType != null">source_type,</if>
            <if test="status != null">status,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="name != null">#{name},</if>
            <if test="producerType != null">#{producerType},</if>
            <if test="sourceType != null">#{sourceType},</if>
            <if test="status != null">#{status},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
        </trim>
    </insert>

    <update id="updatePlayletItemType" parameterType="PlayletItemType">
        update playlet_item_type
        <trim prefix="SET" suffixOverrides=",">
            <if test="name != null">name = #{name},</if>
            <if test="producerType != null">producer_type = #{producerType},</if>
            <if test="sourceType != null">source_type = #{sourceType},</if>
            <if test="status != null">status = #{status},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deletePlayletItemTypeById" parameterType="Long">
        delete from playlet_item_type where id = #{id}
    </delete>

    <delete id="deletePlayletItemTypeByIds" parameterType="String">
        delete from playlet_item_type where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>

</mapper>